"""
/***************************************************************************
 ImportFieldDataDialog
                                 A QGIS plugin
 Topaze
                             -------------------
        begin                : 2022-09-29
        git sha              : $Format:%H$
        copyright            : (C) 2022 by Jean-Mari ARSAC
        email                : jmarsac@arsac.wf
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

import os
from pathlib import Path

from PyQt5 import QtCore, QtWidgets, uic
from qgis.core import QgsProject

from topaze.topaze_utils import TopazeUtils

FORM_CLASS, _ = uic.loadUiType(
    os.path.join(os.path.dirname(__file__), "import_field_data_dialog.ui")
)

from topaze.toolbelt.i18n import tr


class ImportFieldDataDialog(QtWidgets.QDialog, FORM_CLASS):
    def __init__(self, parent=None):
        """Constructor."""
        super(ImportFieldDataDialog, self).__init__(parent)
        # Set up the user interface from Designer.
        # After setupUI you can access any designer object by doing
        # self.<objectname>, and you can use autoconnect slots - see
        # http://qt-project.org/doc/qt-4.8/designer-using-a-ui-file.html
        # #widgets-and-dialogs-with-auto-connect
        self.setupUi(self)

        self.toolButton.clicked.connect(self.showDialog)

    def showDialog(self):
        field_path = Path(QgsProject.instance().homePath()) / "terrain"
        field_path.mkdir(parents=True, exist_ok=True)
        fname, _filter = QtWidgets.QFileDialog.getOpenFileName(
            self,
            tr("Open terrain data file"),
            str(field_path),
            tr(
                "All files (*.*);;LandXML (*.xml);;Leica GSI (*.gsi);;Trimble ARE (*.are);;Trimble Job (*.job);;Text (*.txt);;Azimut (*.obs)"
            ),
        )

        if fname:
            field_data_type = TopazeUtils.get_field_data_type(fname)
            if field_data_type:
                self.label_format.setText(field_data_type)
            else:
                self.label_format.setText(tr("Unknown"))

            self.lineEdit.setText(fname)
